'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.DatePickerRangeField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reduxForm = require('redux-form');

var _formFieldHelpers = require('./validationHelpers/formFieldHelpers');

var _DatePickerRangeRender = require('./renderControl/DatePickerRangeRender');

var _DatePickerRangeRender2 = _interopRequireDefault(_DatePickerRangeRender);

var _modulHelpers = require('modul-helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var parseDate = function parseDate(date) {
	if (!date) {
		return date;
	}
	if (date.replace) {
		return _modulHelpers.dateHelper.parseDate(date, 'd.m.Y');
	}
	return date;
};

var DatePickerRangeField = function (_React$Component) {
	_inherits(DatePickerRangeField, _React$Component);

	function DatePickerRangeField(props) {
		_classCallCheck(this, DatePickerRangeField);

		var _this = _possibleConstructorReturn(this, (DatePickerRangeField.__proto__ || Object.getPrototypeOf(DatePickerRangeField)).call(this, props));

		_this.validators = [];
		_this._createValidators(props);
		return _this;
	}

	_createClass(DatePickerRangeField, [{
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			this._createValidators(nextProps);
		}
	}, {
		key: '_createValidators',
		value: function _createValidators(props) {
			var _validators;

			var required = props.required,
			    requiredDisable = props.requiredDisable,
			    validate = props.validate;

			this.validators.length = 0;
			var requiredFieldValidator = (0, _formFieldHelpers.getRequiredValidator)({ required: required, requiredDisable: requiredDisable });

			(_validators = this.validators).push.apply(_validators, _toConsumableArray(requiredFieldValidator));

			if (validate) {
				var _validators2;

				if (Array.isArray(validate)) (_validators2 = this.validators).push.apply(_validators2, _toConsumableArray(validate));else this.validators.push(validate);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    _props$periods = _props.periods,
			    periods = _props$periods === undefined ? [] : _props$periods,
			    dateFrom = _props.dateFrom,
			    dateTo = _props.dateTo,
			    props = _objectWithoutProperties(_props, ['periods', 'dateFrom', 'dateTo']);

			return _react2.default.createElement(_reduxForm.Field, _extends({}, props, {
				type: 'text',
				validate: this.validators,
				component: _DatePickerRangeRender2.default,
				parse: parseDate,
				periods: periods,
				dateFrom: dateFrom,
				dateTo: dateTo
			}));
		}
	}]);

	return DatePickerRangeField;
}(_react2.default.Component);

DatePickerRangeField.propTypes = {
	required: _propTypes2.default.string,
	validate: _propTypes2.default.array,
	requiredDisable: _propTypes2.default.bool,
	tipPlace: _propTypes2.default.string,
	validators: _propTypes2.default.array,
	periods: _propTypes2.default.array,
	dateFrom: _propTypes2.default.object,
	dateTo: _propTypes2.default.object
};
DatePickerRangeField.defaultProps = {
	periods: []
};
exports.DatePickerRangeField = DatePickerRangeField;