'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.InputField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxForm = require('redux-form');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _InputRender = require('./renderControl/InputRender');

var _InputRender2 = _interopRequireDefault(_InputRender);

var _formFieldHelpers = require('./validationHelpers/formFieldHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputField = function (_React$Component) {
	_inherits(InputField, _React$Component);

	function InputField(props) {
		_classCallCheck(this, InputField);

		var _this = _possibleConstructorReturn(this, (InputField.__proto__ || Object.getPrototypeOf(InputField)).call(this, props));

		_this.validators = [];
		_this._createValidators(props);
		return _this;
	}

	_createClass(InputField, [{
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			this._createValidators(nextProps);
		}
	}, {
		key: '_createValidators',
		value: function _createValidators(props) {
			var _validators;

			var required = props.required,
			    requiredDisable = props.requiredDisable,
			    validate = props.validate;

			this.validators.length = 0;
			var requiredFieldValidator = (0, _formFieldHelpers.getRequiredValidator)({ required: required, requiredDisable: requiredDisable });

			(_validators = this.validators).push.apply(_validators, _toConsumableArray(requiredFieldValidator));

			if (validate) {
				var _validators2;

				if (Array.isArray(validate)) (_validators2 = this.validators).push.apply(_validators2, _toConsumableArray(validate));else this.validators.push(validate);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    _props$type = _props.type,
			    type = _props$type === undefined ? 'text' : _props$type,
			    required = _props.required,
			    requiredDisable = _props.requiredDisable,
			    _props$component = _props.component,
			    component = _props$component === undefined ? _InputRender2.default : _props$component,
			    _props$warn = _props.warn,
			    warn = _props$warn === undefined ? [] : _props$warn,
			    props = _objectWithoutProperties(_props, ['type', 'required', 'requiredDisable', 'component', 'warn']);

			return _react2.default.createElement(_reduxForm.Field, _extends({}, props, {
				type: type,
				validate: this.validators,
				warn: warn,
				component: component
			}));
		}
	}]);

	return InputField;
}(_react2.default.Component);

InputField.defaultProps = {
	validate: []
};
InputField.propTypes = {
	name: _propTypes2.default.string.isRequired,
	format: _propTypes2.default.func,
	normalize: _propTypes2.default.func,
	onBlur: _propTypes2.default.func,
	onChange: _propTypes2.default.func,
	onFocus: _propTypes2.default.func,
	onDragStart: _propTypes2.default.func,
	onDrop: _propTypes2.default.func,
	parse: _propTypes2.default.func,
	required: _propTypes2.default.string, //текст ошибки при отсутствии значения
	requiredDisable: _propTypes2.default.bool, //выключении валидации на обязательность значения
	validate: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.arrayOf(_propTypes2.default.func)]),
	wrapperClassName: _propTypes2.default.string, //стили для дива в который будет завернуть компонент при натягивании валидации
	tipPlace: _propTypes2.default.string, //где будет выводится тултип
	mask: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string])),
	clearable: _propTypes2.default.bool
};
exports.InputField = InputField;