'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PhoneField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxForm = require('redux-form');

var _PhoneRender = require('./renderControl/PhoneRender');

var _PhoneRender2 = _interopRequireDefault(_PhoneRender);

var _formFieldHelpers = require('./validationHelpers/formFieldHelpers');

var _utils = require('./validationHelpers/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
//import normalizePhone from './normalizePhone'
//import inputFieldShape from './inputFieldShape';


var phoneParser = function phoneParser(value) {
    return value.replace(/[^\d]/g, '');
};

var PhoneField = exports.PhoneField = function (_React$Component) {
    _inherits(PhoneField, _React$Component);

    function PhoneField(props) {
        _classCallCheck(this, PhoneField);

        var _this = _possibleConstructorReturn(this, (PhoneField.__proto__ || Object.getPrototypeOf(PhoneField)).call(this, props));

        _this.phoneValidators = [];
        _this._createValidators(props);
        return _this;
    }

    _createClass(PhoneField, [{
        key: 'UNSAFE_componentWillReceiveProps',
        value: function UNSAFE_componentWillReceiveProps(nextProps) {
            this._createValidators(nextProps);
        }
    }, {
        key: '_createValidators',
        value: function _createValidators(props) {
            var _phoneValidators;

            var required = props.required,
                requiredDisable = props.requiredDisable,
                invalidPhoneError = props.invalidPhoneError,
                validate = props.validate;

            this.phoneValidators.length = 0;
            var requiredFieldValidator = (0, _formFieldHelpers.getRequiredValidator)({
                required: required,
                requiredDisable: requiredDisable
            });

            var validPhoneValidator = (0, _utils.validator)(invalidPhoneError, _utils.isValidPhone);

            (_phoneValidators = this.phoneValidators).push.apply(_phoneValidators, _toConsumableArray(requiredFieldValidator).concat([validPhoneValidator]));

            if (validate) {
                var _phoneValidators2;

                if (Array.isArray(validate)) (_phoneValidators2 = this.phoneValidators).push.apply(_phoneValidators2, _toConsumableArray(validate));else this.phoneValidators.push(validate);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var props = _objectWithoutProperties(this.props, []);

            return _react2.default.createElement(_reduxForm.Field, _extends({}, props, {
                type: 'tel', component: _PhoneRender2.default,
                validate: this.phoneValidators,
                parse: phoneParser
            }));
        }
    }]);

    return PhoneField;
}(_react2.default.Component);

PhoneField.defaultProps = {
    validate: [],
    invalidPhoneError: 'Укажите 10 цифр номера мобильного телефона'
};