'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.TextAreaField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxForm = require('redux-form');

var _TextAreaRender = require('./renderControl/TextAreaRender');

var _TextAreaRender2 = _interopRequireDefault(_TextAreaRender);

var _inputFieldShape = require('./inputFieldShape');

var _inputFieldShape2 = _interopRequireDefault(_inputFieldShape);

var _formFieldHelpers = require('./validationHelpers/formFieldHelpers');

var _TextAreaBlockRender = require('./renderControl/TextAreaBlockRender');

var _TextAreaBlockRender2 = _interopRequireDefault(_TextAreaBlockRender);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextAreaField = exports.TextAreaField = function (_React$PureComponent) {
	_inherits(TextAreaField, _React$PureComponent);

	function TextAreaField(props) {
		_classCallCheck(this, TextAreaField);

		var _this = _possibleConstructorReturn(this, (TextAreaField.__proto__ || Object.getPrototypeOf(TextAreaField)).call(this, props));

		_this.fieldRef = _react2.default.createRef();

		_this.focus = function () {
			_this.fieldRef.current.getRenderedComponent().wrappedEl.focus();
		};

		_this.showTooltip = function () {
			_this.fieldRef.current.getRenderedComponent().setManuallyShowTooltip(true);
		};

		_this.hideTooltip = function () {
			_this.fieldRef.current.getRenderedComponent().setManuallyShowTooltip(false);
		};

		_this.validators = [];
		_this._createValidators(props);
		return _this;
	}

	_createClass(TextAreaField, [{
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			this._createValidators(nextProps);
		}
	}, {
		key: '_createValidators',
		value: function _createValidators(props) {
			var _validators;

			var required = props.required,
			    requiredDisable = props.requiredDisable,
			    validate = props.validate;

			this.validators.length = 0;
			var requiredFieldValidator = (0, _formFieldHelpers.getRequiredValidator)({ required: required, requiredDisable: requiredDisable });

			(_validators = this.validators).push.apply(_validators, _toConsumableArray(requiredFieldValidator));

			if (validate) {
				var _validators2;

				if (Array.isArray(validate)) (_validators2 = this.validators).push.apply(_validators2, _toConsumableArray(validate));else this.validators.push(validate);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    _props$type = _props.type,
			    type = _props$type === undefined ? 'text' : _props$type,
			    fieldType = _props.fieldType,
			    _props$component = _props.component,
			    component = _props$component === undefined ? _TextAreaRender2.default : _props$component,
			    props = _objectWithoutProperties(_props, ['type', 'fieldType', 'component']);

			var componentToRender = fieldType === 'textAreaBlock' ? _TextAreaBlockRender2.default : component;

			return _react2.default.createElement(_reduxForm.Field, _extends({}, props, {
				type: type,
				validate: this.validators,
				component: componentToRender,
				ref: this.fieldRef,
				forwardRef: true
			}));
		}
	}]);

	return TextAreaField;
}(_react2.default.PureComponent);

TextAreaField.defaultProps = {
	validate: []
};
TextAreaField.propTypes = _inputFieldShape2.default;