'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.reduxForm = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.searchFocusString = searchFocusString;

var _reduxForm2 = require('redux-form');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//import logger from 'common/helpers/logger';

function searchFocusString(errors) {
    var firstField = Object.keys(errors)[0];
    if (!firstField) return null;

    if (typeof errors[firstField] === 'string' || _typeof(errors[firstField]) === 'object' && 'key' in (errors[firstField] || {})) {
        return firstField;
    } else if (errors[firstField] && _typeof(errors[firstField]) === 'object') if (Array.isArray(errors[firstField])) {
        var fieldIndex = errors[firstField].findIndex(function (item) {
            return !!item;
        });
        var fieldName = Object.keys(errors[firstField][fieldIndex])[0];
        return firstField + '[' + fieldIndex + '].' + fieldName;
    } else {
        var obj = _extends({}, errors);
        var flag = true;
        var i = 0;
        var fieldString = '';
        var field = undefined;
        while (flag && i < 6) {
            field = Object.keys(obj)[0];
            fieldString += (fieldString ? '.' : '') + field;
            if (typeof obj[field] === 'string') {
                flag = false;
            } else {
                obj = obj[field];
            }
            i++;
        }
        return fieldString;
    }
}

var focusOnFailed = function focusOnFailed(errors, form, dispatch) {
    if (errors) {
        var focusString = searchFocusString(errors);
        if (focusString) dispatch((0, _reduxForm2.focus)(form, focusString));
    }
};

var reduxForm = function reduxForm(_ref) {
    var form = _ref.form,
        initialSubmitFailed = _ref.onSubmitFail,
        initialProps = _objectWithoutProperties(_ref, ['form', 'onSubmitFail']);

    return function (Component) {
        var FormComponent = (0, _reduxForm2.reduxForm)(_extends({ form: form }, initialProps))(Component);

        var ReduxForm = function (_React$Component) {
            _inherits(ReduxForm, _React$Component);

            function ReduxForm() {
                _classCallCheck(this, ReduxForm);

                return _possibleConstructorReturn(this, (ReduxForm.__proto__ || Object.getPrototypeOf(ReduxForm)).apply(this, arguments));
            }

            _createClass(ReduxForm, [{
                key: 'handleSubmitFailed',
                value: function handleSubmitFailed(errors, dispatch, submitError) {
                    var propsSubmitFailed = this.props.onSubmitFail;

                    focusOnFailed(errors, form || this.props.form, dispatch);
                    propsSubmitFailed && propsSubmitFailed(errors, dispatch, false);
                    initialSubmitFailed && initialSubmitFailed(errors, dispatch, false);
                    if (!propsSubmitFailed && !initialSubmitFailed) console.warn(submitError);
                }
            }, {
                key: 'render',
                value: function render() {
                    var _props = this.props,
                        onSubmitFail = _props.onSubmitFail,
                        otherProps = _objectWithoutProperties(_props, ['onSubmitFail']);

                    return _react2.default.createElement(FormComponent, _extends({ onSubmitFail: this.handleSubmitFailed.bind(this) }, otherProps));
                }
            }]);

            return ReduxForm;
        }(_react2.default.Component);

        return ReduxForm;
    };
};
exports.reduxForm = reduxForm;