'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _validation = require('../validation');

var _ui = require('@modul/ui');

var _validationHelpers = require('../validationHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AccordionSelectRender = (_dec = (0, _validation.validation)({ tips: true }), _dec(_class = function (_React$Component) {
	_inherits(AccordionSelectRender, _React$Component);

	function AccordionSelectRender(props) {
		_classCallCheck(this, AccordionSelectRender);

		var _this = _possibleConstructorReturn(this, (AccordionSelectRender.__proto__ || Object.getPrototypeOf(AccordionSelectRender)).call(this, props));

		_this.focusator = new _validationHelpers.CustomFocusable();
		return _this;
	}

	_createClass(AccordionSelectRender, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    _props$input = _props.input,
			    onChange = _props$input.onChange,
			    onBlur = _props$input.onBlur,
			    onFocus = _props$input.onFocus,
			    validator = _props.validator,
			    className = _props.className,
			    treeData = _props.treeData,
			    _props$searchInInput = _props.searchInInput,
			    searchInInput = _props$searchInInput === undefined ? false : _props$searchInInput;
			var tooltip = validator.tooltip,
			    addClassName = validator.addClassName;


			if (searchInInput) return _react2.default.createElement(_ui.AccordionSelectSearchInInput, _extends({}, this.props, {
				ref: function ref(field) {
					return field && field.ref && _this2.focusator.init(field.ref);
				},
				tooltipProps: tooltip,
				addClassNames: addClassName + ' ' + className,
				treeData: treeData,
				onSelect: onChange,
				onBlur: onBlur,
				onFocus: onFocus
			}));

			return _react2.default.createElement(_ui.AccordionSelect, _extends({}, this.props, {
				tooltipProps: tooltip,
				addClassNames: addClassName + ' ' + className,
				treeData: treeData,
				onSelect: onChange,
				onBlur: onBlur,
				onFocus: onFocus
			}));
		}
	}]);

	return AccordionSelectRender;
}(_react2.default.Component)) || _class);
AccordionSelectRender.defaultProps = {
	className: ''
};


AccordionSelectRender.propTypes = _ui.AccordionSelect.propTypes;

exports.default = AccordionSelectRender;