"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _validationHelpers = require("../validationHelpers");

var _classnames = require("classnames");

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CheckboxRender = (_dec = (0, _validationHelpers.validation)({ tips: true, hideOnClickOutside: false }), _dec(_class = function (_React$Component) {
	_inherits(CheckboxRender, _React$Component);

	function CheckboxRender(props) {
		_classCallCheck(this, CheckboxRender);

		var _this = _possibleConstructorReturn(this, (CheckboxRender.__proto__ || Object.getPrototypeOf(CheckboxRender)).call(this, props));

		_this.focusator = new _validationHelpers.InputFocusable();
		return _this;
	}

	_createClass(CheckboxRender, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    input = _props.input,
			    label = _props.label,
			    validator = _props.validator,
			    disabled = _props.disabled,
			    readOnly = _props.readOnly,
			    switcher = _props.switcher;
			var tooltip = validator.tooltip,
			    isError = validator.isError;

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement("input", _extends({}, input, {
					ref: function ref(input) {
						return _this2.focusator.init(input);
					},
					type: "checkbox",
					disabled: disabled,
					readOnly: readOnly,
					id: input.name
				})),
				_react2.default.createElement(
					"label",
					{ htmlFor: input.name, className: (0, _classnames2.default)('label-check', { '_error': isError, '_switcher': switcher }) },
					_react2.default.createElement("i", _extends({ className: "icon" }, tooltip)),
					_react2.default.createElement(
						"span",
						null,
						this.props.children
					)
				)
			);
		}
	}]);

	return CheckboxRender;
}(_react2.default.Component)) || _class);
CheckboxRender.defaultProps = {
	disabled: false,
	readOnly: false,
	className: '',
	addClassName: ''
};
exports.default = CheckboxRender;