'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ui = require('@modul/ui');

var _validationHelpers = require('../validationHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DatePickerRender = (_dec = (0, _validationHelpers.validation)({ tips: true }), _dec(_class = function (_React$Component) {
	_inherits(DatePickerRender, _React$Component);

	function DatePickerRender(props) {
		_classCallCheck(this, DatePickerRender);

		var _this = _possibleConstructorReturn(this, (DatePickerRender.__proto__ || Object.getPrototypeOf(DatePickerRender)).call(this, props));

		_this.focusator = new _validationHelpers.CustomFocusable();
		return _this;
	}

	_createClass(DatePickerRender, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    input = _props.input,
			    label = _props.label,
			    className = _props.className,
			    validator = _props.validator,
			    disabled = _props.disabled,
			    timepicker = _props.timepicker,
			    datepicker = _props.datepicker,
			    formatPicker = _props.formatPicker,
			    insideParent = _props.insideParent,
			    allowDates = _props.allowDates,
			    minDate = _props.minDate,
			    maxDate = _props.maxDate,
			    onShow = _props.onShow,
			    readOnly = _props.readOnly,
			    mask = _props.mask,
			    step = _props.step;
			var tooltip = validator.tooltip,
			    addClassName = validator.addClassName;

			var classNames = [className || '', addClassName || ''].join(' ');

			return _react2.default.createElement(_ui.DatePicker, _extends({
				ref: function ref(field) {
					_this2.focusator.init(field);
				},
				autoComplete: 'off'
			}, input, {
				className: classNames,
				placeholder: label,
				disabled: disabled
			}, tooltip, {
				timepicker: timepicker,
				datepicker: datepicker,
				format: formatPicker,
				yearStart: 1900,
				insideParent: insideParent,
				allowDates: allowDates,
				minDate: minDate,
				maxDate: maxDate,
				onShow: onShow,
				readOnly: readOnly,
				mask: mask,
				step: step
			}));
		}
	}]);

	return DatePickerRender;
}(_react2.default.Component)) || _class);
DatePickerRender.propTypes = {
	input: _propTypes2.default.object,
	label: _propTypes2.default.string,
	className: _propTypes2.default.string,
	validator: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.arrayOf(_propTypes2.default.func)]),
	disabled: _propTypes2.default.bool,
	timepicker: _propTypes2.default.any,
	datepicker: _propTypes2.default.any,
	formatPicker: _propTypes2.default.any,
	insideParent: _propTypes2.default.bool,
	minDate: _propTypes2.default.string,
	maxDate: _propTypes2.default.string,
	onShow: _propTypes2.default.func,
	readOnly: _propTypes2.default.bool,
	mask: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]),
	step: _propTypes2.default.number
};
DatePickerRender.defaultProps = {
	insideParent: false,
	readOnly: false,
	mask: true
};
exports.default = DatePickerRender;