'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _validationHelpers = require('../validationHelpers');

var _reactTextMask = require('react-text-mask');

var _reactTextMask2 = _interopRequireDefault(_reactTextMask);

var _ui = require('@modul/ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputRender = (_dec = (0, _validationHelpers.validation)({ tips: true }), _dec(_class = function (_React$Component) {
	_inherits(InputRender, _React$Component);

	function InputRender(props) {
		_classCallCheck(this, InputRender);

		var _this = _possibleConstructorReturn(this, (InputRender.__proto__ || Object.getPrototypeOf(InputRender)).call(this, props));

		_this.focusator = new _validationHelpers.InputFocusable();
		return _this;
	}

	_createClass(InputRender, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    input = _props.input,
			    label = _props.label,
			    className = _props.className,
			    type = _props.type,
			    validator = _props.validator,
			    disabled = _props.disabled,
			    readOnly = _props.readOnly,
			    maxLength = _props.maxLength,
			    autoComplete = _props.autoComplete,
			    mask = _props.mask,
			    clearable = _props.clearable,
			    onKeyDown = _props.onKeyDown,
			    onPaste = _props.onPaste;
			var tooltip = validator.tooltip,
			    addClassName = validator.addClassName;

			var classNames = [className, addClassName].join(' ');
			if (mask) {
				return _react2.default.createElement(_reactTextMask2.default, _extends({}, input, {
					ref: function ref(input) {
						return input && _this2.focusator.init(input.inputElement);
					},
					autoComplete: autoComplete,
					className: classNames,
					placeholder: label,
					type: type,
					disabled: disabled,
					readOnly: readOnly,
					maxLength: maxLength === 0 ? 100000 : maxLength,
					mask: mask,
					guide: false,
					onPaste: onPaste
				}, tooltip));
			}

			if (clearable) {
				return _react2.default.createElement(_ui.InputClearable, _extends({}, input, {
					className: classNames,
					placeholder: label,
					type: type,
					disabled: disabled,
					readOnly: readOnly,
					maxLength: maxLength === 0 ? 100000 : maxLength,
					onKeyDown: onKeyDown,
					inputRef: this.props.inputRef,
					autoFocus: this.props.autoFocus,
					onPaste: onPaste
				}, tooltip));
			}

			return _react2.default.createElement('input', _extends({}, input, {
				ref: function ref(input) {
					return _this2.focusator.init(input);
				},
				autoComplete: autoComplete,
				className: classNames,
				placeholder: label,
				type: type,
				disabled: disabled,
				readOnly: readOnly,
				maxLength: maxLength === 0 ? 100000 : maxLength,
				onKeyDown: onKeyDown,
				onPaste: onPaste
			}, tooltip));
		}
	}]);

	return InputRender;
}(_react2.default.Component)) || _class);
InputRender.defaultProps = {
	disabled: false,
	readOnly: false,
	className: '',
	addClassName: '',
	maxLength: 255
};
exports.default = InputRender;