'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class; // import React from 'react'


var _ui = require('@modul/ui');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _validationHelpers = require('../validationHelpers');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectRender = (_dec = (0, _validationHelpers.validation)({ tips: true, dataOnWrapper: true }), _dec(_class = function (_React$Component) {
	_inherits(SelectRender, _React$Component);

	function SelectRender(props) {
		_classCallCheck(this, SelectRender);

		var _this = _possibleConstructorReturn(this, (SelectRender.__proto__ || Object.getPrototypeOf(SelectRender)).call(this, props));

		_this.state = {
			selectClass: ''
		};

		_this.onFocus = function (e) {
			var fieldInput = _this.props.input;
			// if (this.props.searchable)
			// 	ReactTooltip.show(e.target.parentNode.parentNode.parentNode.parentNode);
			// else
			// 	ReactTooltip.show(e.target.parentNode.parentNode.parentNode);

			fieldInput.onFocus();
			e.stopPropagation();
		};

		_this.onBlurSelect = function (event) {
			var _this$props = _this.props,
			    fieldInput = _this$props.input,
			    onSelectBlur = _this$props.onSelectBlur;

			var onInputBlur = fieldInput.onBlur,
			    input = _objectWithoutProperties(fieldInput, ['onBlur']);

			//ReactTooltip.hide(event.target);


			onInputBlur(input.value);
			if (onSelectBlur) onSelectBlur(event);
		};

		_this.onChangeSelect = function (obj) {
			var _this$props2 = _this.props,
			    fieldInput = _this$props2.input,
			    onSelectChange = _this$props2.onSelectChange,
			    noChange = _this$props2.noChange,
			    _this$props2$valueKey = _this$props2.valueKey,
			    valueKey = _this$props2$valueKey === undefined ? 'value' : _this$props2$valueKey,
			    multi = _this$props2.multi,
			    _this$props2$fullObje = _this$props2.fullObject,
			    fullObject = _this$props2$fullObje === undefined ? false : _this$props2$fullObje;
			var onInputChange = fieldInput.onChange;

			if (onSelectChange) {
				onSelectChange(obj);
			}

			// noChange - не вызывать onChange redux-form, полностью переопределяем с помощью onSelectChange
			if (!noChange) {
				if (multi || fullObject) {
					onInputChange(obj);
				} else {
					onInputChange(obj ? obj[valueKey] : null);
				}
			}
		};

		_this.getScrollingClass = function () {
			// DOMrect, строки поиска
			var rectInput = void 0;
			if (_this.props.input.name && document.getElementsByClassName(_this.props.input.name + '-select').length > 0) {
				rectInput = document.getElementsByClassName(_this.props.input.name + '-select')[0].getBoundingClientRect();
			}

			if (rectInput) {

				// Нода выпадающего меню
				var wrapper = document.getElementById(_this.props.input.name + '-select-wrapper');
				var selectDropDown = wrapper && wrapper.getElementsByClassName && wrapper.getElementsByClassName('Select-menu-outer')[0];

				// DOMrect, обрамляющий выпадающее меню.
				var selectDropDownRect = selectDropDown && selectDropDown.getBoundingClientRect ? selectDropDown.getBoundingClientRect() : {};

				// Расстояние от низа элемента до конца страницы
				var bottomOffset = window.innerHeight - (selectDropDownRect && selectDropDownRect.height ? selectDropDownRect.height : 0) - (rectInput && rectInput.top ? rectInput.top : 0) - (rectInput && rectInput.height ? rectInput.height : 0);

				_this.setState({
					selectClass: bottomOffset < 0 ? 'react-select-open-top' : ''
				});
			}
		};

		_this.focusator = new _validationHelpers.CustomFocusable();
		return _this;
	}

	_createClass(SelectRender, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			// TODO: исправить, костыль
			this.focusator.init(this.refInput);
			//ReactDOM.findDOMNode(this.refInput).setAttribute('data-for', this.props.validator.tooltip['data-for']);
			//ReactDOM.findDOMNode(this.refInput).setAttribute('data-tip', "");

			this.props.scrollCausingDiv && this.props.scrollCausingDiv.addEventListener('scroll', this.getScrollingClass);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    fieldInput = _props.input,
			    className = _props.className,
			    _props$validator = _props.validator,
			    tooltip = _props$validator.tooltip,
			    addClassName = _props$validator.addClassName,
			    onSelectChange = _props.onSelectChange,
			    onSelectBlur = _props.onSelectBlur,
			    _props$valueKey = _props.valueKey,
			    valueKey = _props$valueKey === undefined ? 'value' : _props$valueKey,
			    required = _props.required,
			    scrollCausingDiv = _props.scrollCausingDiv,
			    wrapperClassName = _props.wrapperClassName,
			    _props$fullObject = _props.fullObject,
			    fullObject = _props$fullObject === undefined ? false : _props$fullObject,
			    selectOptions = _objectWithoutProperties(_props, ['input', 'className', 'validator', 'onSelectChange', 'onSelectBlur', 'valueKey', 'required', 'scrollCausingDiv', 'wrapperClassName', 'fullObject']);

			var onInputChange = fieldInput.onChange,
			    onInputBlur = fieldInput.onBlur,
			    input = _objectWithoutProperties(fieldInput, ['onChange', 'onBlur']);

			if (input.value === "") {
				//хак, при пустой строке показывается будто выбран элемент
				input.value = undefined;
			}

			// косты... хак, для связи с селектами ангуляра, которые в большинстве случаев хранят в себе массивы
			if (fullObject && Array.isArray(input.value)) {
				input.value = input.value[0];
			}

			var select = _react2.default.createElement(_ui.Select, _extends({
				ref: function ref(s) {
					return _this2.refInput = s;
				},
				wrapperClassName: (0, _classnames2.default)([wrapperClassName, this.props.input.name + '-select']),
				className: (0, _classnames2.default)([className, addClassName, this.state.selectClass])
			}, input, selectOptions, {
				tooltipProps: tooltip,
				onFocus: this.onFocus,
				onOpen: this.getScrollingClass,
				valueKey: valueKey,
				onChange: this.onChangeSelect,
				onBlur: this.onBlurSelect
			}));

			return scrollCausingDiv ? _react2.default.createElement(
				'div',
				{ id: this.props.input.name + '-select-wrapper' },
				select
			) : select;
		}

		// отменяем всплытие события и вручную вызываем показ tooltip, иначе теряется currentTarget при перерендере


		/**
   * Расчёт дополнительного класса при скролле страницы
   */

	}]);

	return SelectRender;
}(_react2.default.Component)) || _class);


SelectRender.propTypes = _ui.Select.propTypes;

exports.default = SelectRender;