'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _validationHelpers = require('./../validationHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextAreaRender = (_dec = (0, _validationHelpers.validation)({ tips: true }), _dec(_class = function (_React$PureComponent) {
	_inherits(TextAreaRender, _React$PureComponent);

	function TextAreaRender(props) {
		_classCallCheck(this, TextAreaRender);

		var _this = _possibleConstructorReturn(this, (TextAreaRender.__proto__ || Object.getPrototypeOf(TextAreaRender)).call(this, props));

		_this.textAreaRef = _react2.default.createRef();

		_this.focus = function () {
			_this.textAreaRef.current.focus();
		};

		_this.focusator = new _validationHelpers.CustomFocusable();
		return _this;
	}

	_createClass(TextAreaRender, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.focusator.init(this);
		}
	}, {
		key: 'setFocus',
		value: function setFocus() {
			this.focus();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    input = _props.input,
			    label = _props.label,
			    className = _props.className,
			    type = _props.type,
			    validator = _props.validator,
			    disabled = _props.disabled,
			    rows = _props.rows,
			    wrap = _props.wrap,
			    maxLength = _props.maxLength,
			    _props$autoFocus = _props.autoFocus,
			    autoFocus = _props$autoFocus === undefined ? false : _props$autoFocus,
			    topText = _props.topText,
			    availableLength = _props.availableLength,
			    bottomText = _props.bottomText;
			var tooltip = validator.tooltip,
			    addClassName = validator.addClassName;

			var classNames = [className || '', addClassName || ''].join(' ');
			return _react2.default.createElement(
				'div',
				_extends({ className: 'textarea_block' }, tooltip),
				topText && _react2.default.createElement(
					'div',
					{ className: 'textarea_text first_line' },
					topText
				),
				_react2.default.createElement('textarea', _extends({}, input, {
					ref: this.textAreaRef,
					className: classNames,
					placeholder: label,
					type: type,
					disabled: disabled,
					rows: rows,
					wrap: wrap,
					maxLength: maxLength,
					autoFocus: autoFocus
				})),
				_react2.default.createElement('div', { className: 'textarea_border' }),
				_react2.default.createElement(
					'div',
					{ className: 'textarea_text', charsleft: '\u041E\u0441\u0442\u0430\u043B\u043E\u0441\u044C \u0441\u0438\u043C\u0432\u043E\u043B\u043E\u0432: ' + availableLength },
					bottomText
				)
			);
		}
	}]);

	return TextAreaRender;
}(_react2.default.PureComponent)) || _class);
exports.default = TextAreaRender;