'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ui = require('@modul/ui');

var _validationHelpers = require('../validationHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UploadRender = (_dec = (0, _validationHelpers.validation)({ tips: true }), _dec(_class = function (_React$Component) {
	_inherits(UploadRender, _React$Component);

	function UploadRender(props) {
		_classCallCheck(this, UploadRender);

		var _this = _possibleConstructorReturn(this, (UploadRender.__proto__ || Object.getPrototypeOf(UploadRender)).call(this, props));

		_this.focusator = new _validationHelpers.InputFocusable();
		return _this;
	}

	_createClass(UploadRender, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    input = _props.input,
			    meta = _props.meta,
			    hideTips = _props.hideTips,
			    validator = _props.validator,
			    disabled = _props.disabled,
			    children = _props.children,
			    onDropFile = _props.onDropFile,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['input', 'meta', 'hideTips', 'validator', 'disabled', 'children', 'onDropFile', 'className']);

			var tooltip = validator.tooltip,
			    addClassName = validator.addClassName;

			var classNames = [className || '', addClassName || ''].join(' ');

			return _react2.default.createElement(
				_ui.DropZone,
				_extends({}, input, {
					getRef: function getRef(input) {
						return _this2.focusator.init(input);
					},
					disabled: disabled,
					onDrop: function onDrop(files) {
						input.onBlur(files);
						if (typeof onDropFile === 'function') {
							onDropFile(files);
						}
					},
					className: classNames
				}, props, tooltip),
				children
			);
		}
	}]);

	return UploadRender;
}(_react2.default.Component)) || _class);
exports.default = UploadRender;