'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRequiredValidator = exports.getRandomKey = exports.getErrorMessage = exports.showSuccessBorder = exports.showErrorBorder = exports.ifCondition = undefined;

var _utils = require('./utils');

var ifCondition = exports.ifCondition = function ifCondition(condition, value) {
  var defaultVal = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

  return condition ? value : defaultVal;
};

/**
 * Подсветка бордера инпута
 * @param error - есть ошибка
 * @param valid - валидное состояние
 * @param visited - поле было под фокусом
 * @param submitFailed - не удачная отправка формы
 * @returns {*}
 */
var showErrorBorder = exports.showErrorBorder = function showErrorBorder(_ref) {
  var valid = _ref.valid,
      error = _ref.error,
      touched = _ref.touched,
      submitFailed = _ref.submitFailed;

  return (!valid || error) && (touched || submitFailed);
};

/**
 * Подсветка бордера инпута
 * @param error - есть ошибка
 * @param visited - поле было в фокусе
 * @param valid - валидное состояние
 * @param active - фокус в поле
 * @returns {*}
 */
var showSuccessBorder = exports.showSuccessBorder = function showSuccessBorder(_ref2) {
  var valid = _ref2.valid,
      visited = _ref2.visited,
      error = _ref2.error,
      active = _ref2.active;

  return (valid || !error) && visited && !active;
};

/**
 * Показывать тултип с ошибкой
 */
var getErrorMessage = exports.getErrorMessage = function getErrorMessage(_ref3) {
  var error = _ref3.error,
      touched = _ref3.touched,
      submitFailed = _ref3.submitFailed;

  return error && (submitFailed || touched) ? error : null;
};

var getRandomKey = exports.getRandomKey = function getRandomKey() {
  return Math.floor(Math.random() * (999999999 - 100000000)) + 100000000;
};

var getRequiredValidator = exports.getRequiredValidator = function getRequiredValidator(_ref4) {
  var _ref4$required = _ref4.required,
      required = _ref4$required === undefined ? false : _ref4$required,
      _ref4$requiredDisable = _ref4.requiredDisable,
      requiredDisable = _ref4$requiredDisable === undefined ? false : _ref4$requiredDisable;

  return required && !requiredDisable ? [(0, _utils.isRequired)(required)] : [];
};