"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function radValidate() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { tips: true },
        tips = _ref.tips;

    return function (WrappedComponent) {
        var radValidateTooltip = function (_React$Component) {
            _inherits(radValidateTooltip, _React$Component);

            function radValidateTooltip(props, context) {
                _classCallCheck(this, radValidateTooltip);

                var _this = _possibleConstructorReturn(this, (radValidateTooltip.__proto__ || Object.getPrototypeOf(radValidateTooltip)).call(this, props, context));

                _this.validatorId = Math.floor(Math.random() * (999999999 - 100000000)) + 100000000;
                _this.tooltipId = "tooltip_" + _this.validatorId;
                return _this;
            }

            _createClass(radValidateTooltip, [{
                key: "getError",
                value: function getError() {
                    return this.props.field.error;
                }
            }, {
                key: "showTooltipError",
                value: function showTooltipError() {
                    var _props$field = this.props.field,
                        hasError = _props$field.hasError,
                        error = _props$field.error,
                        wasSubmit = _props$field.wasSubmit,
                        blured = _props$field.blured,
                        focused = _props$field.focused;

                    return hasError && error && (wasSubmit || blured) && focused;
                }

                // TODO: showTooltipHint
                // showTooltipHint() {
                //   const {field: {hasError, error, touched, submitFailed, isPristine}} = this.props;
                //   return hasError && error && (submitFailed || touched);
                // }

            }, {
                key: "getTooltipProps",
                value: function getTooltipProps(tipPlace) {
                    var self = this;
                    return {
                        placement: tipPlace || "top",
                        preventHideOnFocus: false,
                        getContent: self.getError.bind(self),
                        className: "error",
                        trigger: 'manual',
                        showInitial: true,
                        hideOnClickOutside: true,
                        html: true
                    };
                }
            }, {
                key: "getHintTooltipProps",
                value: function getHintTooltipProps(tipPlace) {
                    var self = this;
                    return {
                        placement: tipPlace || "top",
                        preventHideOnFocus: false,
                        getContent: self.getError.bind(self),
                        className: "",
                        trigger: 'manual',
                        showInitial: true,
                        hideOnClickOutside: true,
                        html: true
                    };
                }
            }, {
                key: "getTooltipConfig",
                value: function getTooltipConfig(_ref2) {
                    var id = _ref2.id;

                    return {
                        'data-mtip': id
                    };
                }
            }, {
                key: "render",
                value: function render() {
                    var _props = this.props,
                        field = _props.field,
                        _props$hideTips = _props.hideTips,
                        hideTips = _props$hideTips === undefined ? false : _props$hideTips,
                        _props$wrapperClassNa = _props.wrapperClassName,
                        wrapperClassName = _props$wrapperClassNa === undefined ? '' : _props$wrapperClassNa;

                    var _props2 = this.props,
                        tipPlace = _props2.tipPlace,
                        wrappedProps = _objectWithoutProperties(_props2, ["tipPlace"]);

                    var isValid = field.isValid,
                        hasError = field.hasError,
                        focused = field.focused,
                        wasSubmit = field.wasSubmit,
                        hint = field.hint,
                        blured = field.blured;


                    var tooltip = this.getTooltipConfig({ id: this.tooltipId });

                    var highlightError = (!isValid || hasError) && (wasSubmit || blured);
                    var highlightSuccess = (isValid || !hasError) && blured;
                    var addClassName = (highlightError && 'error') + " " + (highlightSuccess && 'success');

                    var validator = {
                        error: hasError,
                        isError: highlightError,
                        isSuccess: highlightSuccess,
                        addClassName: addClassName,
                        tooltip: tooltip
                    };

                    if (tips && !hideTips) {
                        var showErrorMessage = this.showTooltipError();
                        var showHintMsg = !showErrorMessage && focused && hint;
                        var tooltipProps = this.getTooltipProps(tipPlace);
                        if (showHintMsg) {
                            tooltipProps = this.getHintTooltipProps(tipPlace);
                        }

                        return _react2.default.createElement(
                            "div",
                            { className: wrapperClassName },
                            _react2.default.createElement(WrappedComponent, _extends({}, wrappedProps, {
                                validator: validator })),
                            showErrorMessage && _react2.default.createElement(ModulTooltip, _extends({
                                dataFor: this.tooltipId
                            }, tooltipProps))
                        );
                    }
                    return _react2.default.createElement(WrappedComponent, _extends({}, this.props, {
                        validator: validator }));
                }
            }]);

            return radValidateTooltip;
        }(_react2.default.Component);

        return radValidateTooltip;
    };
}